#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>
#include <fcntl.h>
#include <signal.h>

#include <stdio.h>
#include <errno.h>
#include <sys/time.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>

#define MAXHOSTNAME 80
void reusePort(int sock);   

struct video {
char numvideo[2];
char nomvideo[40];
char duravideo[3];
time_t horainicio;
time_t maximahora;
char mail[30];
} programa[20],temporal;


char puertomulticast3[30];
char canalmulticast3[30];
char usuariotemp[30];
char correo[40];
char num[2];
char duracion[3];
char nombre[40];
char numero[2];
char maxhora[3];
char nose[24];
time_t tiempo;
time_t ahora;
double alaire;
int cont,cont2;
char num[2];
char duracion[3];
char nombre[40];
char lugar[40];
char mandar[90];
char cambionombre[70];
char nombrearchivo[60];
char nombrearchivo2[60];
int letras;
FILE *fpt;

main( argc, argv )
int argc;
char *argv[];
{
  int   sd, psd;
  struct   sockaddr_in server;
  struct  hostent *hp, *gethostbyname();
  struct  servent *sp;
  struct sockaddr_in from;
  int fromlen;
  int length;
  char ThisHost[80];


  for (cont=0;cont<=19;cont++)
		programa[cont].numvideo[0]='*';
		

  sp = getservbyname("echo", "tcp");
  /* get EchoServer Host information, NAME and INET ADDRESS */

  gethostname(ThisHost, MAXHOSTNAME);

  printf("----TCP/Server running at host NAME: %s\n", ThisHost);
  if  ( (hp = gethostbyname(ThisHost)) == NULL ) {
    fprintf(stderr, "Can't find host %s\n", ThisHost);
    exit(-1);
  }
  bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);
  printf("    (TCP/Server INET ADDRESS is: %s )\n", inet_ntoa(server.sin_addr));


  /* Construct name of socket to send to. */
  server.sin_family = hp->h_addrtype;
  /*OR server.sin_family = AF_INET; */


  server.sin_addr.s_addr = htonl(INADDR_ANY);

  /*OR    server.sin_port = sp->s_port; */
  if (argc == 2)
      server.sin_port = htons(atoi(argv[1])); 
  else
      server.sin_port = htons(0);  

  /*   Create socket on which to send  and receive */

  /* sd = socket (PF_INET,SOCK_DGRAM,0); */
  sd = socket (hp->h_addrtype,SOCK_STREAM,0);

  if (sd<0) {
    perror("opening stream socket");
    exit(-1);
  }

  reusePort(sd);

  if ( bind( sd, &server, sizeof(server) ) ) {
    close(sd);
    perror("binding name to stream socket");
    exit(-1);
  }

  length = sizeof(server);
  if ( getsockname (sd,&server,&length) ) {
    perror("getting socket name");
    exit(0);
  }

  printf("Server Port is: %d\n", ntohs(server.sin_port));
  listen(sd,4);
  fromlen = sizeof(from);
  for(;;){
    psd  = accept(sd, &from, &fromlen);
    if ( fork() == 0) {
      close (sd);
      EchoServe(psd, from);
    }


  }

}

EchoServe(psd, from)
int psd;
struct sockaddr_in from;
{
  char buf[1024];
  int rc;
  struct  hostent *hp, *gethostbyname();
  char arterisco[3];
  pid_t hijo3;

  printf("Serving %s:%d\n", inet_ntoa(from.sin_addr),
      ntohs(from.sin_port));
  if ((hp = gethostbyaddr((char*)&from.sin_addr.s_addr,
      sizeof(from.sin_addr.s_addr),AF_INET)) == NULL)
    fprintf(stderr, "Can't find host %s\n", inet_ntoa(from.sin_addr));
  else
    printf("(Name is : %s)\n", hp->h_name);


  /*      get data from  clients and send it back */

  read(psd, nombrearchivo, 60);
  read(psd, puertomulticast3,30);
  read(psd, canalmulticast3,30);

  letras=strlen(nombrearchivo);

  for (cont=0;cont<=letras;cont++)
  	if (nombrearchivo[cont]=='/'){
  		for(cont2=0;cont2<=59;cont2++)
  			nombrearchivo2[cont2]=' ';
  		for (cont2=cont;cont2<letras;cont2++)
  			nombrearchivo2[cont2-cont]=nombrearchivo[cont2+1];
  	}

  if ((hijo3 = fork()) < 0) {
        perror("fork1");
        exit(1);
  }

  if (hijo3 == 0) {
       	execl("multicastreceiver", "multicastreceiver", canalmulticast3, puertomulticast3, 0);
       	perror("exec1");
       	_exit(127);
  }



  read(psd,arterisco,3);	


  //printf("\n%s\n%s\n%s\n%s\n",nombrearchivo,puertomulticast3,canalmulticast3,arterisco);






  strcpy(cambionombre,"mv recibido ");
  strcat(cambionombre, nombrearchivo2);
  write(1,cambionombre,70);
  write(1,"\n",1);
  system(cambionombre);
  close(psd);
  exit(0);
}
void reusePort(int s)
{
  int one=1;

  if ( setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(char *) &one,sizeof(one)) == -1 )
  {
    printf("error in setsockopt,SO_REUSEPORT \n");
    exit(-1);
  }
}      
