#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>
#include <fcntl.h>
#include <signal.h>

#include <stdio.h>
#include <errno.h>
#include <sys/time.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>
#define MAXHOSTNAME 80
#define BUFSIZE 1024
char buf[BUFSIZE];
char rbuf[BUFSIZE];

char numvideo[2];
char maximahora[3];
char usuario[20];
char dato4[24];
char duracion[3];
char nomvideo[40];
char ruta[40];

main( argc, argv )
int argc;
char *argv[];
{
  int   sd;
  struct   sockaddr_in server;
  struct  hostent *hp, *gethostbyname();
  struct  servent *sp;
  struct sockaddr_in from;
  struct sockaddr_in addr;
  int fromlen;
  int length;
  int rc, cc;
  char ThisHost[80];

  strcpy(usuario,"rodrigo");
  sp = getservbyname("echo", "tcp");
  /* get TCPClient Host information, NAME and INET ADDRESS */

  gethostname(ThisHost, MAXHOSTNAME);

  printf("----TCP/Cleint running at host NAME: %s\n", ThisHost);
  if  ( (hp = gethostbyname(ThisHost)) == NULL ) {
    fprintf(stderr, "Can't find host %s\n", ThisHost);
    exit(-1);
  }
  bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);
  printf("    (TCP/Cleint INET ADDRESS is: %s )\n", inet_ntoa(server.sin_addr));

  /* get TCP/Server Host information, NAME and INET ADDRESS */

  if  ( (hp = gethostbyname(argv[1])) == NULL ) {
    addr.sin_addr.s_addr = inet_addr(argv[1]);
    if ((hp = gethostbyaddr((void *)&addr.sin_addr.s_addr,
        sizeof(addr.sin_addr.s_addr),AF_INET)) == NULL) {
      fprintf(stderr, "Can't find host %s\n", argv[1]);
      exit(-1);
    }
  }
  printf("----TCP/Server running at host NAME: %s\n", hp->h_name);
  bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);
  printf("    (TCP/Server INET ADDRESS is: %s )\n", inet_ntoa(server.sin_addr));

  /* Construct name of socket to send to. */
  server.sin_family = hp->h_addrtype;
  /* server.sin_family = AF_INET; */

  server.sin_port = htons(atoi(argv[2]));
  /*OR    server.sin_port = sp->s_port; */

  /*   Create socket on which to send  and receive */

  sd = socket (hp->h_addrtype,SOCK_STREAM,0);
  /*OR  sd = socket (PF_INET,SOCK_STREAM,0); */

  if (sd<0) {
    perror("opening stream socket");
    exit(-1);
  }
  /* Connect to TCP/SERVER */
  if ( connect(sd, (struct sockaddr *)&server, sizeof(server)) < 0 ) {
    close(sd);
    perror("connecting stream socket");
    exit(0);
  }
  fromlen = sizeof(from);
  if (getpeername(sd, (struct sockaddr *)&from,&fromlen)<0){
    perror("could't get peername\n");
    exit(1);
  }
  printf("Connected to TCP/Server:");
  printf("%s:%d\n", inet_ntoa(from.sin_addr),
      ntohs(from.sin_port));
  if ((hp = gethostbyaddr((void *)&from.sin_addr.s_addr,
      sizeof(from.sin_addr.s_addr),AF_INET)) == NULL)
    fprintf(stderr, "Can't find host %s\n", inet_ntoa(from.sin_addr));
  else
    printf("(Name is : %s)\n", hp->h_name);


  /*     get data from USER, send it SERVER,
      receive it from SERVER, display it back to USER  */

  for(;;) {
    //printf("\nType anything followed by RETURN, or type CTRL-D to exit\n");

    printf("\n1 - Ver lista de videos\n");
    printf("2 - Agregar un video\n");
    printf("3 - Quitar un video\n");
    printf("CTRL-D - Salir\n");

    cleanup(buf);
    cleanup(rbuf);
    rc=read(0,buf, sizeof(buf));
    if (rc == 0) break;
    if (send(sd, buf, rc, 0) <0 )
      perror("sending stream message");

    if (strncmp(buf,"1",1)==0){
    	while(recv(sd, rbuf, sizeof(rbuf), 0) > 1){
    		printf("\n%s",rbuf);
    		cleanup(rbuf);
    	}
    	printf("\n");
    }		

    if (strncmp(buf,"2",1)==0){
		
        write(1,"\nIngrese nombre del video\n",26);
        scanf("%s",nomvideo);
        send(sd,nomvideo,sizeof(nomvideo),0);
        write(1,"\nIngrese duracion\n",18);
        write(1,"en tres cifras, ej. '012'\n",26);
        scanf("%s",duracion);
        send(sd,duracion,3,0);
		write(1,"\nIngrese ruta del video\n",24);
        scanf("%s",ruta);
        send(sd,ruta,sizeof(ruta),0);

		write(1,"\n",1);

	}

    if (strncmp(buf,"3",1)==0){
		
        write(1,"\nIngrese numero del video\n",26);
        write(1,"En dos cifras ejemplo '02'\n",27);
        scanf("%s",numvideo);
        send(sd,numvideo,2,0);
        write(1,"\n",1);

	}


    /*if ((cc=recv(sd, rbuf, sizeof(rbuf), 0)) < 0)
      perror("receiving echo");
    if (cc == rc)
      if (strcmp(buf, rbuf) == 0){
        printf("Echo is good\n");
        printf("  Received: %s", rbuf);
      }
      else
        printf("Echo bad -- strings unequal: %s\n", rbuf);
    else
      printf("Echo bad -- lengths unequal: %s\n", rbuf);*/
  }
  printf ("EOF... exit\n");
  close(sd);
  exit (0);
}
cleanup(buf)
char *buf;
{
  int i;
  for(i=0; i<BUFSIZE; i++) buf[i]='\0';
}
